package org.norgg.hopesington;

import flash.display.BitmapData;
import nape.shape.Shape;
import nape.phys.Body;
import nape.phys.BodyType;
import nape.shape.Polygon;
import nape.phys.Material;
import nape.geom.Vec2;

import nme.Assets;
import nme.display.Sprite;
import nme.display.DisplayObjectContainer;

class Building extends Entity {
	public var w = 16;
	public var h = 15;
	
	public var shape: Shape;
	
	public var complete = 0.0;
	public var pos: Vec2;
	
	var texture: BitmapData;
	
	public function new(parent: DisplayObjectContainer, pos: Vec2) {
		super();
		
		if (texture == null) {
			texture = Assets.getBitmapData("img/house.png");
		}

		this.pos = pos;
		x = Math.round(pos.x);
		y = Math.round(pos.y);

		parent.addChild(this);
	}
	
	public function onComplete() {
		
	}
		
	public function construct(builder: Person) {
		if (complete >= 1) return;
		
		if (body != null) body.space = null;
		
		complete += 0.1;

		var completedHeight = Std.int(4 + complete * (h-4));
		if (completedHeight > h) completedHeight = h;
		
		body = new Body();
		body.type = BodyType.STATIC;
		shape = new Polygon(Polygon.rect(0, h-completedHeight, w, completedHeight));
		body.shapes.add(shape);
		
		var material = new Material(0, 0, 0, 1, 0.001);
		body.setShapeMaterials(material);
		
		body.position = pos;
		body.userData.blocks = true;
		body.userData.building = this;
		body.space = Main.space;
		
		graphics.clear();
		graphics.beginBitmapFill(texture, null, false);
		graphics.drawRect(0, h - completedHeight, w, completedHeight);
		
		if (complete >= 1) {
			onComplete();
		}
	}
}