package org.norgg.hopesington;

import nape.geom.Vec2;

class PathStep {
	public var x: Int;
	public var y: Int;
	public var cost = 1.0;
	public var parent: PathStep;

	public function new(x: Int, y: Int, parent: PathStep = null) {
		this.x = x;
		this.y = y;
		this.parent = parent;
	}
	
	public function updateCost() {
		if (parent == null) {
			cost = 1;
		} else {
			cost = costWithParent(parent);
		}
	}
	
	public function costWithParent(testParent: PathStep) {
		return testParent.cost + distTo(testParent.vec2());
	}
	
	public function distTo(target: Vec2) {
		return target.sub(vec2(), true).length;
	}
	
	public function vec2() {
		return Vec2.weak(x, y);
	}
}