package org.norgg.hopesington;
import nme.display.Sprite;

import nme.display.DisplayObjectContainer;

import nape.geom.Vec2;
import nape.phys.Body;
import nape.phys.BodyType;

class Projectile extends Entity {
	var destroyed = false;
		
	public var owner: Person;

	public function new(parent: DisplayObjectContainer, pos: Vec2, vel: Vec2, owner: Person ) {
		super();
		
		this.owner = owner;
		parent.addChild(this);
		Main.projectiles.add(this);
	}
	
	public function update() {
		x = body.position.x;
		y = body.position.y;
		rotation = 360 * body.rotation/(Math.PI * 2);
	}
	
	public function destroy() {
		if (destroyed) return;
		destroyed = true;

		body.space = null;
		parent.removeChild(this);
	}
}