package org.norgg.hopesington;

import nme.Assets;
import nme.display.DisplayObjectContainer;
import nape.geom.Vec2;

class Temple extends Building {
	public static inline var baseWidth = 48;
	public static inline var baseHeight = 48;
	
	public function new(parent: DisplayObjectContainer, pos: Vec2) {
		super(parent, pos);

		texture = Assets.getBitmapData("img/temple.png");
		w = Temple.baseWidth;
		h = Temple.baseHeight;
		complete = -0.02;
		construct(null);
	}
	
	override public function onComplete() {
		Assets.getSound("snd/complete.wav").play();
	}
	
	override public function construct(builder: Person) {
		if (complete >= 1) return;
		complete -= 0.09;
		super.construct(builder);
		if (builder != null) {
			builder.age += 200;
		}
	}
}