package org.norgg.hopesington;
import flash.display.BitmapData;
import nape.phys.Material;
import nme.display.Sprite;

import nape.callbacks.InteractionType;
import nape.dynamics.InteractionGroup;
import nme.display.DisplayObjectContainer;

import nape.geom.Vec2;
import nape.phys.Body;
import nape.phys.BodyType;
import nape.shape.Polygon;

import nme.Assets;

class Tree extends Entity {
	public static inline var w = 12;
	public static inline var h = 20;
	
	public var remaining = 1.2;
	var destroyed = false;
	var pos: Vec2;
	
	var texture: BitmapData;
	
	public function new(parent: DisplayObjectContainer, pos: Vec2) {
		super();
		this.pos = pos;
		x = Math.round(pos.x);
		y = Math.round(pos.y);
		parent.addChild(this);
		
		if (Math.random() < 0.25) {
			texture = Assets.getBitmapData("img/tree1.png");
		} else if (Math.random() < 0.5) {
			texture = Assets.getBitmapData("img/tree2.png");
		} else if (Math.random() < 0.75) {
			texture = Assets.getBitmapData("img/tree3.png");
		} else {
			texture = Assets.getBitmapData("img/tree4.png");
		}

		harvest();
	}
	
	public function harvest() {
		if (destroyed) return false;
		
		remaining -= 0.2;
		
		if (remaining <= 0.1) {
			destroyed = true;
			Main.trees.remove(this);
			body.space = null;
			parent.removeChild(this);
			//Main.m.addTree();
			return true;
		}
		
		if (body != null) body.space = null;
		
		body = new Body();
		body.type = BodyType.STATIC;
		body.shapes.add(new Polygon(Polygon.rect(0, h-h*remaining, w, h*remaining)));
		
		var material = new Material(0, 0, 0, 1, 0.001);
		body.setShapeMaterials(material);
		
		body.position = pos;
		body.userData.blocks = true;
		body.userData.tree = this;
		body.space = Main.space;
		
		graphics.clear();
		graphics.beginBitmapFill(texture, null, false);
		graphics.drawRect(0, h - h * remaining, w, h * remaining);
		return true;
	}
}